#include <fstream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
using namespace std;
const char D[] = "U2.txt";
const char R[] = "U2rez.txt";
//---
struct sportininkai
{string vardas;
 int nr;
 int laikas;
};
//---
void Skaitymas (sportininkai S[], sportininkai V[], sportininkai M[], int &vyr, int &mot);
void Rikiavimas (int kiek, sportininkai mas[]);
void Spausdinti (sportininkai V[], int vyr, sportininkai M[], int mot);
//---
int main()
{
  sportininkai S[30],V[30],M[30];
  int vyr=0;
  int mot=0;
  Skaitymas (S,V,M,vyr,mot);
  Rikiavimas (mot,M);
  Rikiavimas (vyr,V);
  Spausdinti (V,vyr,M,mot);
  return 0;
}
//---
void Skaitymas (sportininkai S[], sportininkai V[], sportininkai M[], int &vyr, int &mot)
{
  fstream fd(D);
  char eil[21];
  int n,m,h,mi,s,laiknr,b1,b2,b3,b4;
  fd >> n;
  for (int i=0; i<n; i++)
{
    fd.ignore(256,'\n');
    fd.get(eil,20);
    S[i].vardas = eil;
    fd >> S[i].nr >> h >> mi >> s;
    S[i].laikas = 3600*h+60*mi+s;
}
  fd >> m;
  for (int i=0; i<m; i++)
{
      fd >> laiknr;
      if (laiknr<200)
      {
        fd >> h >> mi >> s >> b1 >> b2;
        for (int j=0; j<n; j++)
        {
            if (laiknr == S[j].nr)
                M[mot].vardas = S[j].vardas;
            M[mot].nr = laiknr;
            M[mot].laikas = (3600*h+60*mi+s+(5-b1)*60+(5-b2)*60)-S[j].laikas;
            mot++;
        }
      }

      else
      {
        fd >> h >> mi >> s >> b1 >> b2 >> b3 >> b4;
        for (int j=0; j<n; j++)
        {
            if (laiknr == S[j].nr)
                V[vyr].vardas = S[j].vardas;
            V[vyr].nr = laiknr;
            V[vyr].laikas = (3600*h+60*mi+s+(5-b1)*60+(5-b2)*60)-S[j].laikas;
            vyr++;
        }
      }
}
  fd.close();
}
//---
void Rikiavimas (int kiek, sportininkai mas[])
{
    for (int i=0; i<kiek; i++)
        for (int j=0; j<kiek-1; j++)
        if ((mas[j].laikas > mas[j+1].laikas) || (mas[j].laikas == mas[j+1].laikas) && (mas[j].vardas > mas[j+1].vardas))
        swap (mas[j],mas[j+1]);
}
//---
void Spausdinti (sportininkai V[], int vyr, sportininkai M[], int mot)
{
    ofstream fr(R);
    fr << "Merginos" <<endl;
    for (int i=0; i<mot; i++)
        fr << M[i].nr << " " << M[i].vardas << " " << M[i].laikas/3600 << " " << M[i].laikas%3600/60 << " " << M[i].laikas%60<<endl;
    fr << "Vaikinai" <<endl;
    for (int i=0; i<vyr; i++)
        fr << V[i].nr << " " << V[i].vardas << " " << V[i].laikas/3600 << " " << V[i].laikas%3600/60 << " " << V[i].laikas%60<<endl;

    fr.close();
}
